// vtimer.h

#ifndef _VTIMER_H_
#define _VTIMER_H_

#include "stacklist.h"

struct vtimer_start {
   unsigned long long start : 48;
   unsigned rcount : 16; // recursion count.  if 0, timer is off.
};

struct vtimer {
   unsigned counter_type; // set to ((PERFCTR_NUM << 16) |  kapi_hwcounter_kind)
   unsigned wall_timer; // if == 1, include events switched out
   uint64_t total_field;
   struct vtimer_start start_field; // 64 bits

   // Stop Routine: update saved_timer.auxdata, vtimer.total_field using
   //               read of hardware counter & set vtimer.start_field.start = 0
   void (*stop_routine)(struct vtimer *, struct saved_timer *,
                        unsigned type);
   /* kptr_t stop_routine; */


   // Restart Routine: use aux_data.rcount and read of hardware counter to
   //                  set vtimer.start_field, and update vtimer.total_field
   //                  if counting events switched out
   void (*restart_routine)(struct vtimer *, uint64_t /*auxdata*/,
                           unsigned type, unsigned wtime);
   /* kptr_t restart_routine; */
};

// offsets from start of vtimer
#define counter_type_offset (0)
#define wall_timer_offset (sizeof(unsigned))
#define total_field_offset (2*sizeof(unsigned))
#define start_field_offset (total_field_offset + sizeof(uint64_t))
#define stop_routine_offset (start_field_offset + sizeof(struct vtimer_start))
#define restart_routine_offset (stop_routine_offset + sizeof(void*))
#define sizeof_vtimer (restart_routine_offset + sizeof(void*))

#endif
